﻿using LoongCAD.Geometry;
using LoongCAD.STC.Plugins;
using LoongCAD.Util;
namespace BoxBeamS13
{
    public class CreateStairController : CustomCompCreateController
    {
        public CreateStairController(ComponentPlugin plugin) : base(plugin)
        {


        }

        /// <summary>
        /// 选中的控制点
        /// </summary>
        public static readonly string CTRL_POS_0 = "ctrl_pos_0";
        /// <summary>
        /// 选中的控制点
        /// </summary>
        public static readonly string CTRL_POS_1 = "ctrl_pos_1";


        private Vec3 m_pos0;
        private Vec3 m_pos1;

        int m_state;

        public override void OnActive(DObject paras)
        {
            base.OnActive(paras);
            CreateInfo.UserData = new DObject();
            SwitchStep0();
        }

        private void SwitchStep0()
        {
            SetTip("开始创建：选择第一个控制点");
            SetCursor(LoongCAD.STC.Define.MouseCursor.CURSOR_CROSS);
            BeginSnapPoint();
            m_state = 0;
        }

        private void SwitchStep1()
        {
            SetTip("选择第二个控制点");
            SetCursor(LoongCAD.STC.Define.MouseCursor.CURSOR_CROSS);
            //BeginSnapPoint();
            m_state = 1;
        }

        public override void OnDeactive()
        {
            m_state = 0;
            CreateInfo.UserData = null;
            base.OnDeactive();
        }

        public override void OnSnapPoint(Vec3 pt)
        {
            base.OnSnapPoint(pt);
            if (m_state == 0)
            {
                m_pos0 = pt;
                CreateInfo.UserData[CTRL_POS_0] = m_pos0;
                SwitchStep1();
            }
            else if (m_state == 1)
            {
                m_pos1 = pt;
                CreateInfo.UserData[CTRL_POS_1] = m_pos1;
                m_state = 0;
                CompleteCreation();
                Quit();
            }
        }


        public override void OnSnapRevert()
        {
            if (m_state == 1)
            {
                SwitchStep0();
            }
            base.OnSnapRevert();
        }

    }
}
